import ruis
import sys
import thread

warning = ruis.warning_printer("TERMINAL")

class terminal(ruis.FileType):

    def __init__(self,*a,**kw):
        ruis.FileType.__init__(self,*a,**kw)
        try:
            self._getch, self._restore_term = _Getch()
        except:
            warning("initialization failed, falling back to stdin/stdout")
            self._getch = lambda: sys.stdin.readline()[:-1]
            self._restore_term = lambda: None
            
        self._auto_getch=0

    def __del__(self):
        self._restore_term()

    def getch(self):
        return self._getch()


########################################################################
#
# Platform independent implementation for getch(). Modified from source:
# http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/134892
#
########################################################################
        
def _Getch():
    """Gets a single character from standard input.  Does not echo to
    the screen.
    """
    try:
        impl=_GetchWindows()
        restore=lambda: None
    except ImportError:
        impl,restore=_GetchUnix()
    return impl,restore

def _GetchUnix():
    import sys, tty, termios
    fd=sys.stdin.fileno()
    old_settings = termios.tcgetattr(fd)
    def getch():
        try:
            tty.setraw(sys.stdin.fileno())
            ch = sys.stdin.read(1)
        finally:
            termios.tcsetattr(fd,termios.TCSADRAIN,old_settings)
        return ch
    def restore():
        termios.tcsetattr(fd,termios.TCSADRAIN,old_settings)
    return getch, restore

def _GetchWindows():
    import msvcrt
    return msvcrt.getch

