def start_game():
    import time
    import ruis
    fs = RUIS_ROOT
    
    c0 = fs['/dev/console']
    c1 = fs['/conn/rp/1/dev/console']

    def broadcast(msg):
        for c in c0, c1: c.write(msg)

    def keyboard(index, playercon, line):
        s = line.strip().lower()
        if s == 'r': playercon.write('You chose: ROCK\n')
        elif s == 's': playercon.write('You chose: SCISSORS\n')
        elif s == 'p': playercon.write('You chose: PAPER\n')
        elif s == 'q': broadcast('Quitting...\n')
        else:
            playercon.write('Choose R, S, P or Q.\n')
            ruis.async(playercon.readline)
            return
        chosen[index] = s

    c0['/events/return:readline'].set_callback(lambda s: keyboard(0,c0,s))
    c1['/events/return:readline'].set_callback(lambda s: keyboard(1,c1,s))

    score=[0, 0]

    broadcast('\nThe game starts!\n')
    c0.write('You are player 1\n')
    c1.write('You are player 2\n')

    while True:
        broadcast('Choose R)ock S)cissors P)aper or Q)uit\n')

        chosen = [None, None]
        ruis.async(c0.readline)
        ruis.async(c1.readline)
        while None in chosen and not 'q' in chosen:
            time.sleep(0.2)
        
        if 'q' in chosen: break
        if chosen[0]==chosen[1]: broadcast('It was a tie.\n')
        elif chosen in [['p','r'], ['r','s'], ['s','p']]:
            c0.write('You WON!\n')
            c1.write('You lost.\n')
            score[0]+=1
        else:
            c0.write('You lost.\n')
            c1.write('You WON!\n')
            score[1]+=1
        broadcast('Score player 1: %s, player 2: %s\n\n' % tuple(score))

    broadcast('Closing connections.\n')
    fs['/conn/rp'].remove('1')
