#!/usr/bin/env python
import sys
try: PORT=int(sys.argv[1])
except: PORT=5555
print("RPS server listening to port %s" % (PORT,))

import time
import ruis
import inspect
fs=ruis.newfs(('ruis_modules', '/conn/rp$'))

import rps

def wait_for_players():
    while len(fs['/conn/rp'].ls()) < 2:
        p = fs['/conn/rp'].create('listen:tcp:%s' % PORT)
        fs['/conn/rp/' + p + '/dev/console'].write('Please wait...')
    return fs['/conn/rp'].ls()

game_number = 1
while True:
    p1, p2 = wait_for_players()
    p1_host = fs['/conn/rp'].connection(p1).get_host()
    p1_root = fs['/conn/rp/' + p1]
    ruis.async(p1_root['/conn/rp'].create,
               'listen:tcp:%s' % (PORT+game_number))
    fs['/conn/rp/'+p2+'/conn/rp'].create(
        'tcp://%s:%s' % (p1_host, PORT+game_number))
    p1_root['/modules'].create(inspect.getsource(rps), name='rps')
    ruis.async(p1_root['/modules/rps'].start_game)
    time.sleep(0.5)
    fs['/conn/rp'].remove(p1)
    fs['/conn/rp'].remove(p2)
    game_number+=1
